package enonce;


import java.util.ArrayList;
import java.util.ConcurrentModificationException;
import java.util.HashMap;


import javafx.geometry.Point2D;
import javafx.scene.Node;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;


public class BlobQueue {
	int size = 30;
	HashMap<Integer, ArrayList<Point2D>> cursors;
	
	//TODO 1

	GraphicsContext gc;
	
	private int getNewID() {
		int i = 0;
		while (cursors.keySet().contains(i)) {
			i++;
		}
		return i;
	}
	
	public BlobQueue(GraphicsContext graphicsContext) 
	{
		cursors=new HashMap<Integer,ArrayList<Point2D>>();
		gc = graphicsContext;
		//TODO 1
	}
	
	public void add(int id, Point2D p) 
	{
		ArrayList<Point2D> list = new ArrayList<Point2D>();
		list.add(p);
		cursors.put(id,list);
	}
	
	public void update(int id, Point2D p) 
	{
		cursors.get(id).add(p);
	}
	
	public void remove(int id) 
	{
		//TODO 1
		cursors.remove(id);
	}
	
	public ArrayList<Integer> fingerIDs()
	{
		return new ArrayList<Integer>(this.cursors.keySet());
	}
	
	

	public void draw() 
	{
		try {
			for(int i : cursors.keySet()) {
				Point2D p = cursors.get(i).get(cursors.get(i).size()-1);
				gc.setFill(Color.PINK);
				gc.fillOval(p.getX() - size/2, p.getY() - size/2, size, size);
				
				gc.setStroke(Color.BLACK);
				gc.strokeOval(p.getX() - size/2, p.getY() - size/2, size, size);
								
				// Text with id
				gc.setFill(Color.BLACK);
				gc.fillText("" + i, p.getX()-3, p.getY()+4);
	
			}
		}
		catch (ConcurrentModificationException e) {
			System.out.println("Exception ConcurrentModificationException to fix!");
		}
	}
		
	public boolean checkId(int id) {
		return (cursors.keySet().contains(id));
	}

	public int add(Point2D p) {
		for(int i : cursors.keySet()) 
		{
			Point2D p2 = cursors.get(i).get(cursors.get(i).size()-1);
			if ((p2.subtract(p)).magnitude() < size/2.0) {
				return i;
			}
		}
		int newid = getNewID();
		add(newid, p);	
		return newid;
	}

	public void update(Point2D p) {
		for(int i : cursors.keySet()) {
			Point2D p2 = cursors.get(i).get(cursors.get(i).size()-1);
			if ((p2.subtract(p)).magnitude() < size/2.0) {
				return;
			}
		}
	}

	
	public void remove(Point2D p) {
		for(int i : cursors.keySet()) {
			Point2D p2 = cursors.get(i).get(cursors.get(i).size()-1);
			if ((p2.subtract(p)).magnitude() < size/2.0) 
			{
				remove(i);
				return;
			}
		}
	}
	

	public Point2D getCurrentPoint(int id) 
	{
		return cursors.get(id).get(cursors.get(id).size()-1);
	}
	
	public Point2D getLastPoint(int id) 
	{
		return cursors.get(id).get(cursors.get(id).size()-2);
	}
	
	
	
	//TODO 1 - completer/corriger la declaration
	public void addNodeForId(int id,Node n )
	{

	}

	//TODO 1 - completer/corriger la declaration
	public int getNbFingers() {
		return 0;
	}

	//TODO 1 - completer/corriger la declaration
	public Node getTouchNode(int id)
	{
		return null;
	}
	
	

}
